<?php
class MessageBusiness_SMTPConnect_Model_Email_Template extends Mage_Core_Model_Email_Template
{
    public function send($email, $name=null, array $variables = array())
    {
        if (!Mage::getStoreConfig('smtpconnect/settings/enabled'))
        {
            return parent::send($email, $name, $variables);
        }
        if(!$this->isValidForSend()) {
			Mage::logException(new Exception('This email is not valid.')); 
            return false;
        }
		if (is_array($name)) {
			$name = $name[0];
		} else if (is_null($name)) {
            $name = substr($email, 0, strpos($email, '@'));
        }

        $variables['email'] = $email;
        $variables['name'] = $name;

        $mail = $this->getMail();
        if (is_array($email)) {
            foreach ($email as $emailOne) {
                $mail->addTo($emailOne, $name);
            }
        } else {
            $mail->addTo($email, $name);
        }

        $this->setUseAbsoluteLinks(true);
        $text = $this->getProcessedTemplate($variables, true);

        if($this->isPlain()) {
            $mail->setBodyText($text);
        } else {
            $mail->setBodyHTML($text);
        }

        $mail->setSubject($this->getProcessedTemplateSubject($variables));
        $mail->setFrom($this->getSenderEmail(), $this->getSenderName());

        $transport = Mage::helper('smtpconnect')->getTransport();
        try {
            $mail->send($transport);
            $this->_mail = null;
        }
        catch (Exception $e) {
			$this->_mail = null;
            Mage::logException($e);
            return false;
        }
        return true;
    }
}